#! ruby

require 'jww'
require 'config'
#require 'jcode'
#require "sample"
require "matrix"

$stderr=open("error.log","w")
$KCODE="SJIS"


def senkigou
  syokika
  infile="jw_opt4k.dat" #o̓t@C
  infile=OutDir+"/"+infile
  scale=@scale
  ln0 =Jwc["hhp1ln"].zahyo.round_n(5)
  zu  = Arg["Z"].to_i # 1ŎA2Ő}
  col = Arg["C"].to_i # 1ňp
  syu = Arg["S"].to_i
  lay = Arg["L"].to_i
  name= Arg["N"]
  #col2,syu2,lay2,="","",""
  unless FileTest.directory?(OutDir)
    puts "he #{OutDir}/ ܂Bconfig.rb ύXĉB"
    exit 0
  end
  if FileTest.file?(infile)
    dat=open(infile,"a")
  else
    dat=open(infile,"w")
    dat.print "#\n100\n999\n"
  end
  dat.print "1    #{name}\n"
  #dat.print "  110 10 -20    0  20 0\n"
  dat.print "  110 10 #{ln0.x1} #{ln0.y1} #{ln0.x2} #{ln0.y2}\n"
  if zu==1 #
    dat.print "  800  1\n"
  elsif zu==2 #}
    dat.print "  700  #{1.0/scale}\n"
  end
  col2,syu2,lay2="-1","-1","-1"
  @jwc_temp.each{|line|
    case line
    when /^lc/  ;col2=$'.chomp if col==1
    when /^lt/  ;syu2=$'.chomp if syu==1
    when /^ly/  ;lay2=$'.chomp if lay==1
    when /^\s+-?\d/ 
      ln=line.split.zahyo.round_n(5)
      next if ln==ln0
      dat.print "   01 01 #{ln.join('  ')} #{col2} #{syu2} #{lay2}\n"
    when /^ci/ 
      ci=line.sub(/ci/,"").split.zahyo.round_n(5)
      if ci.size==3
	dat.print "   01 01 #{ci.x} #{ci.y} 0 360 "
	dat.print "#{col2} #{syu2} #{lay2} e #{ci.r}\n"
      else
	dat.print "   01 01 #{ci.x} #{ci.y} #{ci.shikaku} #{ci.syukaku} "
	dat.print "#{col2} #{syu2} #{lay2} e #{ci.r}\n"
      end
    end
  }
  dat.print "999\n"
  puts "he #{infile}mFĉB"
end

def kyori_3d
  syokika
  ln=[]
  1.upto(99) do |i|
    ln << Jwc["hhp#{i}ln"].zahyo if Jwc["hhp#{i}ln"]
  end
  c2=Jwc["c2"].zahyo
  lt =Arg["T"] ? Arg["T"] :"1"
  lc =Arg["C"] ? Arg["C"] :"9"
  cnl=Arg["L"] ? Arg["L"] :"1"
  cnz=Arg["Z"] ? Arg["Z"] :"2"
  par=Arg["P"] ? Arg["P"] :"1"
  onl=Arg["O"] ? Arg["O"] :"1"
  puts "lc#{lc}"
  puts "lt#{lt}"
  
  #ZT
  lnz=[]
  ln.each_with_index do |e,i|
    z1,z2=0,0
    c2.each do |f|
      if (f[0,2].round_a(10)==e.pts.round_a(10) or
          f[0,2].round_a(10)==e.pte.round_a(10)) and
          (e.x1-e.x2)*f[3]-(e.y1-e.y2)*f[2]<0.001
        if f[0,2].round_a(10)==e.pts.round_a(10)
          z1=f[4].split(",")[0].to_f
          z2=f[4].split(",")[1].to_f if f[4].split(",")[1]
        else
          z2=f[4].split(",")[0].to_f
          z1=f[4].split(",")[1].to_f if f[4].split(",")[1]
        end
      end
    end
    vec1=Vector[e.x1,e.y1,z1*1000]
    vec2=Vector[e.x2,e.y2,z2*1000]
    #p vec1; p vec2
    lnz[i]=[vec1,vec2]
  end
  
  #p=a+s*da
  #q=b+t*db
  #s={|db|^2*(abEda)-(daEdb)*(abEdb)}/{|da|^2*|db|^2-(daEdb)^2}
  #t={(daEdb)*(abEdb)-|da|^2*(abEdb)}/{|da|^2*|db|^2-(daEdb)^2}
  for i in 0..ln.size-2
    oa,ob=lnz[i][0],lnz[i][1]
    for j in i+1..ln.size-1
      oc,od=lnz[j][0],lnz[j][1]
      ab,cd,ac=ob-oa,od-oc,oc-oa
      s,t=min_sen_sen(ab,cd,ac)
      #p oa;  p ob;  p oc;  p od;  p s;  p t
      if s.infinite? or s.nan? or
          t.infinite? or t.nan? #s̏
        next if /2/=~par
        if ab.r<=cd.r
          t1=min_ten_sen(oa,oc,cd)[0]
          t2=min_ten_sen(ob,oc,cd)[0]
          if t1>=0 and t1<=1
            s,t=0,t1
          elsif t2>=0 and t2<=1
            s,t=1,t2
          else
            s,t=min_tanmatsu(oa,ob,oc,od)[0,2]
          end
        else
          s1=min_ten_sen(oc,oa,ab)[0]
          s2=min_ten_sen(od,oa,ab)[0]
          if s1>=0 and s1<=1
            s,t=s1,0
          elsif s2>=0 and s2<=1
            s,t=s2,1
          else
            s,t=min_tanmatsu(oa,ob,oc,od)
          end
        end
      end
      if s<0 or s>1 or t<0 or t>1 #ɂȂꍇ̏
        next if /2/=~onl
        arr=[]
        arr[0]=[0,min_ten_sen(oa,oc,cd)[0],min_ten_sen(oa,oc,cd)[1]]
        arr[1]=[1,min_ten_sen(oa,oc,cd)[0],min_ten_sen(oa,oc,cd)[1]]
        arr[2]=[min_ten_sen(oc,oa,ab)[0],0,min_ten_sen(oc,oa,ab)[1]]
        arr[3]=[min_ten_sen(oc,oa,ab)[0],1,min_ten_sen(oc,oa,ab)[1]]
        arr[4]=min_tanmatsu(oa,ob,oc,od)
        #p arr
        arr1=arr.reject{|e| e[0]<0 or e[0]>1}.
          reject{|e| e[1]<0 or e[1]>1}.
          sort{|e,f| e[2]<=>f[2]}[0]
        s,t=arr1[0],arr1[1]
        #p s;p t
      end
      p,q=oa+ab*s,oc+cd*t
      ptp,ptq=[p[0],p[1]],[q[0],q[1]]
      #p s; p p
      pz=(p[2]/1000).round_n(3).to_s
      qz=(q[2]/1000).round_n(3).to_s
      pq=((p-q).r/1000).round_n(3).to_s
      #puts_pt(ptp);puts_pt(ptq)
      ptt=(ptp+ptq).tyuuten
      deg=(ptp+ptq).senkakudo
      if ptp.round_a(8)==ptq.round_a(8)
        ptp=ptp.move([oa[0],oa[1]],0.1)
        ptq=ptq.move([oc[0],oc[1]],0.1)
      end
      puts_ln(ptp+ptq)
      puts "cn#{cnz}"
      puts_moji([ptp.x,ptp.y,ptq.x-ptp.x,ptq.y-ptp.y,pz],"c2")
      puts_moji([ptq.x,ptq.y,ptp.x-ptq.x,ptp.y-ptq.y,qz],"c2")
      puts "cn#{cnl}"
      puts_moji2(ptt+[deg,pq],8,"cn#{cnl}","ch")
    end
  end
end

def min_sen_sen(ab,cd,ac)
  s=(cd.r**2*ac.inner_product(ab)-
     (ab.inner_product(cd))*(ac.inner_product(cd)))/
    (ab.r**2*cd.r**2-(ab.inner_product(cd))**2)
  t=((ab.inner_product(cd))*(ac.inner_product(ab))-
     ab.r**2*(ac.inner_product(cd)))/
    (ab.r**2*cd.r**2-(ab.inner_product(cd))**2)
  return [s,t]
end

def min_ten_sen(op,oa,ab)
  s=(-(oa.inner_product(ab))+op.inner_product(ab))/ab.r**2
  oq=oa+ab*s
  pq=(oq-op).r
  return [s,pq]
end

def min_tanmatsu(oa,ob,oc,od)
  u=[(od-ob).r,(oc-ob).r,(oc-oa).r,(od-oa).r].sort[0]
  s,t=1,1 if u==(od-ob).r
  s,t=1,0 if u==(oc-ob).r
  s,t=0,0 if u==(oc-oa).r
  s,t=0,1 if u==(od-oa).r
  return [s,t,u]
end

class Array
  def round_a(num)
    return self.map{|e| e.round_n(num)}
  end
end

def gradation
  syokika
  unless Jwc["hhp1ln"]
    puts "he قȂQIĉB"
  end
  ln1=Jwc["hhp1ln"].zahyo
  ln2=Jwc["hhp2ln"].zahyo
  pt2=Jwc["hp2ln"].zahyo
  color_s0="255,255,0"
  color_e0="0,255,255"
  pitch=0.1
  arg=ARGV[1..-1].join(",")
  if arg
    if /S([\d|\,].*)/=~arg
      color_s0=$1
    elsif  /Sr/i=~arg
      color_s0="#{rand(255)},#{rand(255)},#{rand(255)}"
    end
    if /E([\d|\,].*)/=~arg
      color_e0=$1
    elsif  /Er/i=~arg
      color_e0="#{rand(255)},#{rand(255)},#{rand(255)}"
    end
    if /P([\d|\.].*)/=~arg
      pitch=$1.to_f
      pitch=0.1 if pitch<=0
    end
  end
  #p color_s0
  #p color_e0
  if /,/=~color_s0
    color_s=color_s0.split(",").collect{|e| e.to_i}[0,3]
  else
    int=color_s0.to_i
    color_s=[int%256,(int/256)%256,(int/256*256)%256]
  end
  if /,/=~color_e0
    color_e=color_e0.split(",").collect{|e| e.to_i}[0,3]
  else
    int=color_e0.to_i
    color_e=[int%256,(int/256)%256,(int/256*256)%256]
  end
  #p color_s;  p color_e;  p pitch
  pitch*=@scale
  pts=ln2.far_pt(pt2)
  pte=ln2.near_pt(pt2)
  num=(ln2.nagasa/pitch).to_i
  ln=[]
  color=color_s
  red  =(color_e[0]-color_s[0])/num.to_f
  green=(color_e[1]-color_s[1])/num.to_f
  blue =(color_e[2]-color_s[2])/num.to_f
  #print "red  =";p red
  #print "green=";p green
  #print "blue =";p blue
  ptm=[(pte.x-pts.x)/num,(pte.y-pts.y)/num]
  puts "lc10 #{color[0]+color[1]*256+color[2]*256*256}"
  if num==0
    "he sb`e܂B"
    exit 0
  end
  0.upto(num) do |i|
    #ln<<ln1.inc([ptm.x*i,ptm.y*i])
    color_n=[(color_s[0]+red*i).to_i,
      (color_s[1]+green*i).to_i,
      (color_s[2]+blue*i).to_i]
    unless color==color_n
      color=color_n
      puts "lc10 #{color[0]+color[1]*256+color[2]*256*256}"
    end
    sl="sl"
    ln1.inc([ptm.x*i,ptm.y*i]).each{|e| sl+=sprintf(" %.14f",e)}
    puts sl
  end
end

def rainbow
  syokika
  ci1=Jwc["hhp1ci"].zahyo
  pitch=Arg["P"] ? Arg["P"].to_f : 0.1
  haba=Arg["W"] ? Arg["W"].to_f : 50.0
  if ci1.r<haba
    puts "he L܂"
    exit 0
  end
  if ci1.size==3
    x,y,r,deg1,deg2,henp,jiku=
      ci1[0],ci1[1],ci1[2],0.0,360.0,1.0,0.0
  else
    x,y,r,deg1,deg2,henp,jiku=
      ci1[0],ci1[1],ci1[2],ci1[3],ci1[4],ci1[5],ci1[6]
  end
  #ci ( x y r np@Ip@Ε@p )
  #se ( x y r Ε Xp np ~ʊp ~tOj
  ci2=[x,y,r,henp,rad(jiku),rad(deg1),rad(deg2-deg1),0]
  num=(haba/(pitch*6)).round
  col=[[255,0,0],[255,165,0],[255,255,0],[0,255,0],
    [0,191,255],[0,0,255],[160,32,240]]
  dcol2=[]
  (1..6).each do |i|
    dcol2<<[(col[i][0]-col[i-1][0]).to_f/num,
      (col[i][1]-col[i-1][1]).to_f/num,
      (col[i][2]-col[i-1][2]).to_f/num]
  end
  color=[255,0,0]
  puts "lc10 #{color[0]+color[1]*256+color[2]*256*256}"
  if num<=6
    puts "he ܂B"
    exit 0
  end
  0.upto(6) do |j|
    color=col[j] 
    color_p=col[j]
    0.upto(num) do |i|
      color_n=[(color[0]+dcol2[j][0]*i).to_i,
        (color[1]+dcol2[j][1]*i).to_i,
        (color[2]+dcol2[j][2]*i).to_i]
      color_n.collect!{|e|
        e=255 if e>255
        e=0 if e<0
        e}
      unless color_p==color_n
        color_p=color_n
        puts "lc10 #{color_p[0]+color_p[1]*256+color_p[2]*256*256}"
      end
      se="se"
      ci2.each{|e| se+=sprintf(" %.14f",e)}
      puts se
      ci2[2]=ci2[2]-pitch
    end
  end
end

def copy_sendan
  syokika
  deg1 =Arg["D"] ? Arg["D"].to_f : 30.0 #f
  deg2 =Arg["E"] ? Arg["E"].to_f : 20.0 #]
  x    =Arg["X"] ? Arg["X"].to_f : 2.0
  y    =Arg["Y"] ? Arg["Y"].to_f : 1.0
  p1=Jwc["hp1"].zahyo
  pt1=Jwc["hp1"].zahyo if Jwc["hp1"]
  p1=Matrix[[pt1.x],[pt1.y]]
  if Arg["A"]    #ٔ{
    m0=Matrix[[x,0],[0,y]]
  elsif Arg["B"] #f
    m0=Matrix[[1,-tan(rad(deg1))],[0,1]]
  elsif Arg["C"] #AC\
    m0=Matrix[[cos(rad(deg2)),-sin(rad(deg2))],
      [sin(rad(deg2)),cos(rad(deg2))]]*
      Matrix[[1,-sin(rad(deg1))],[0,cos(rad(deg1))]]
  end
  jwc_temp=@jwc_temp
  @jwc_temp.each do |tmp|
    case tmp
    when /^hq/
      puts "hd" if Arg["Z"]
    when /^pt/
      pt=tmp.split.zahyo[1,2]
      pt=Matrix[[pt.x],[pt.y]]
      puts_pt((m0*pt+p1).to_a.flatten)
    when /^\s+-?\d/
      ln=tmp.split.zahyo
      pt1=Matrix[[ln.x1],[ln.y1]]
      pt2=Matrix[[ln.x2],[ln.y2]]
      puts_ln((m0*pt1+p1).to_a.flatten+(m0*pt2+p1).to_a.flatten)
    when /^ci|^sc|^se|^so|^sg/ 
      cit=tmp.split(" ")[1..-1].zahyo
      if /^ci/=~tmp
        if cit.size==3
          ci=[cit.x,cit.y,cit.r,0.0,0.0,1.0,0.0]
        else
          ci=cit
        end
      else
        #se ( x y r Ε Xp np ~ʊp ~tOj
        #ci ( x y r np@Ip@Ε@p )
        ci=[cit.x,cit.y,cit.r,deg(cit[5]),
          deg(cit[6])+deg(cit[5]),cit[3],deg(cit[4])]
      end
      a,b,sita=ci.r,ci.r*ci.henp,rad(ci.jiku)
      m1=Matrix[[cos(sita),-sin(sita)],[sin(sita),cos(sita)]]
      m2=Matrix[[a,0],[0,b]]
      m3=m0*m1*m2
      a1,b1,c1,d1=m3[0,0],m3[0,1],m3[1,0],m3[1,1]
      delta=0.5*(atan2(-b1+c1,a1+d1)+atan2(b1+c1,a1-d1))
      fai  =0.5*(atan2(-b1+c1,a1+d1)-atan2(b1+c1,a1-d1))
      n1=Matrix[[cos(delta),-sin(delta)],[sin(delta),cos(delta)]]
      n3=Matrix[[cos(fai),-sin(fai)],[sin(fai),cos(fai)]]
      n2=n1.inv*m3*n3.inv
      p,q=n2[0,0],n2[1,1]
      pt1=Matrix[[ci.x],[ci.y]]         #ϊOS
      ps =Matrix[[ci.pts.x],[ci.pts.y]] #ϊOn_
      pe =Matrix[[ci.pte.x],[ci.pte.y]] #ϊOI_
      pc =m0*pt1+p1                     #ϊ㒆S
      #npAIp̌vZ
      ps2=m0*ps+p1-pc
      pe2=m0*pe+p1-pc
      ps3=(n2.inv*n1.inv*ps2).to_a.flatten
      pe3=(n2.inv*n1.inv*pe2).to_a.flatten
      deg1=([0,0]+ps3).senkakudo
      deg2=([0,0]+pe3).senkakudo 
      pc=pc.to_a.flatten
      ci2=pc+[p,deg1,deg2,q/p,deg(delta)]
      if /^ci/=~tmp
        if ci2[5]==1.0 and ci2[3]==ci2[4]
          ci2=ci2[0,3]
        end
        puts_ci(ci2)
      else
        sc=tmp.split[0]
        #ci ( x y r np@Ip@Ε@p )
        #se ( x y r Ε Xp np ~ʊp ~tOj
        p ci2
        cit2=[ci2.x,ci2.y,ci2.r,ci2[5],rad(ci2[6]),
          rad(ci2[3]),rad(ci2[4]-ci2[3])%(2*PI)]
        cit2[6]=2*PI if cit2[6]==0.0
        cit2.each{|e| sc+=sprintf(" %.14f",e)}
        if /^sc|se/=~tmp
          sc+=" #{cit[7].to_i}" 
        elsif /^so|sg/=~tmp
          naien=cit[7]*p/a
          sc+=sprintf(" %.14f",naien)
        end
        puts sc
      end
    when /^sl/
      sl=tmp.sub(/sl/,"").split(" ").zahyo
      sl2,sl3=[],[]
      0.step(sl.size-2,2){|i| sl2[i/2]=[sl[i],sl[i+1]]}
      sl2.each do |e|
        pt=Matrix[[e.x],[e.y]]
        sl3<<(m0*pt+p1).to_a
      end
      sl3.flatten!
      sl4="sl"
      sl3.each{|e| sl4+=sprintf(" %.14f",e)}
      puts sl4
    else 
      puts tmp
    end
  end
end

def sunpou_settei
  require 'fileutils'
  if Arg["1"] 
    file="my.jwf"
    puts "he @ݒ my.jwf ɐݒ肵܂"
  elsif Arg["2"] 
    file="jw_win.jwf"
    puts "he @ݒ jw_win.jwf ɐݒ肵܂"
  elsif Arg["3"] 
    file="@ݒP"
    puts "he @ݒ ݒP ɐݒ肵܂"
  elsif Arg["4"] 
    file="@ݒQ"
    puts "he @ݒ ݒQ ɐݒ肵܂"
  elsif Arg["5"] 
    file="@ݒR"
    puts "he @ݒ ݒR ɐݒ肵܂"
  elsif Arg["6"] 
    file="@ݒS"
    puts "he @ݒ ݒS ɐݒ肵܂"
  elsif Arg["7"] 
    file="@ݒT"
    puts "he @ݒ ݒT ɐݒ肵܂"
  end 
  #p FileTest.file?("sample.rb")
  #File.rename("config.rb","config.bak")
  #open("config.rb") {|old|
  #  open("config.bak","w") {|new| 
  #    while line = old.gets
  #      new.print line
  #    end}}
  FileUtils.cp("config.rb","config.bak") 
  open("config.bak") {|old|
    open("config.rb","w") {|new|
      while line = old.gets
        if /^Jwf_file/=~ line 
          new.print "Jwf_file=\"#{file}\"\n"
          print "Jwf_file=\"#{file}\"\n"
        else 
          new.print line
          print line
        end
      end }}
end 

def sunpou_kousa
  # @
  # @}`̂܂܂ɂĂꍇ
  # #  ̂ĂsRgAEg(擪  #)
  require 'matrix'
  syokika
  $stdout=open("jwc_temp.txt","w")
  hs,hcw,hcd,hch,hcp=[],[],[],[],[]
  scale,lg,z3,cc,cn=1,1,0,0,0
  cn_w,cn_h,cn_d,cn_p=1,1,1,1
  #p Arg
  jougen=Arg["J"] ? Arg["J"].split("KAGEN")[0] : ""
  kagen=Arg["K"] ? Arg["K"].sub(/AGEN/,"") : ""
  kagen=Arg["J"] ? Arg["J"].split("KAGEN")[1] : kagen
  kagen=kagen ? kagen : ""
  if Arg["2"] #}
    puramai=Arg["M"] ? "}" + Arg["M"] : "" 
  elsif Arg["3"]
    puramai=Arg["M"] ? Arg["M"] : "" 
  end 
  puramai=puramai ? puramai : "" 
  #p Arg["M"]
  #p puramai
  # ̋󔒂
  jougen=jougen.sub(/\s\Z/,"")
  kagen=kagen.sub(/\s\Z/,"")
  puramai=puramai.sub(/\s\Z/,"")
  #p jougen
  #p kagen
  @jwc_temp.each{|line|
    case line
    when /^hq/  ;puts "hd"
    when /^hs/  ;puts line ;hs =line.split.zahyo
    when /^hcw/ ;puts line ;hcw=line.split.zahyo
    when /^hch/ ;puts line ;hch=line.split.zahyo
    when /^hcd/ ;puts line ;hcd=line.split.zahyo
    when /^hcc/ ;puts line ;hcp=line.split.zahyo
    when /^cc/ ;puts line ;cc=line.sub(/cc/,"").to_f
    when /^lg/  ;puts line
      lg=line.sub(/lg/,"").hex
      scale=hs[lg+1].to_f
    when /^cn\d/;puts line 
      if /cn0/=~line
        cn=line.split.zahyo
        #hosei_k=(cn[1]+cn[3])*scale*0.25
        cn_w=cn[1]/2
        cn_h=cn[2]/2
        cn_d=cn[3]/2
        cn_p=cn[4]
      else
        cn=line.sub(/cn/,"").to_f
        #hosei_k=(hcw[cn]+hcd[cn])*scale*0.25
        cn_w=hcw[cn]/2
        cn_h=hch[cn]/2
        cn_d=hcd[cn]/2
        cn_p=hcp[cn]
      end
    when /^z3/
      puts "z3"
      z3=1
    when /^(cs|cr|co|cp|ch)/
      cs=line.split.zahyo
      ctype=$&
      v0=Vector[cs[1],cs[2]]
      va=Vector[cs[3],cs[4]]
      vb=Matrix[[0,-1],[1,0]]*va
      vb=vb*(2*cn_h/vb.r)
      vc=v0+va+vb*0.5
      #vc=v0+va+vb*0.5     if cc==0
      #vc=v0+va*0.5+vb*0.5 if cc==1
      #vc=v0+vb*0.5        if cc==2
      #vc=v0+va            if cc==3
      #vc=v0+va*0.5        if cc==4
      #vc=v0               if cc==5
      #vc=v0+va-vb*0.5     if cc==6
      #vc=v0+va*0.5-vb*0.5 if cc==7
      #vc=v0-vb*0.5        if cc==8
      #pt1=[v0[0],v0[1]]
      #pt2=[(v0+va)[0],(v0+va)[1]]
      pt3=[vc[0],vc[1]]
      puts "z3" if /cs|cr|co|cp/=~ctype   # 
      puts line
      #puts_pt(pt3)
      puts "cn0 #{cn_w} #{cn_h} #{cn_d} #{cn_p}"
      if Arg["1"] #
        puts "cc0"
        puts "z3" if /cs|cr|co|cp/=~ctype   # 
        puts "ch #{pt3.x} #{pt3.y} #{cs[3]} #{cs[4]} \"#{jougen}"
        puts "cc6"
        puts "z3" if /cs|cr|co|cp/=~ctype   # 
        puts "ch #{pt3.x} #{pt3.y} #{cs[3]} #{cs[4]} \"#{kagen}"
        #p cn
      elsif Arg["2"] or Arg["3"] #}  
        puts "cc3"
        puts "z3" if /cs|cr|co|cp/=~ctype   # 
        puts "ch #{pt3.x} #{pt3.y} #{cs[3]} #{cs[4]} \"#{puramai}"
      end 
      puts "cc#{cc.to_i}"
      if cn.is_a?(Array)
        puts "cn0 #{cn[1,-1].join(" ")}" if cn[1,-1]
      else
        puts "cn#{cn.to_i}"
      end 
    when /^msg/ ;puts "z3" # 
    else        ;puts line
    end}
  puts "hr"
end 

def moji_chikan
  syokika
  before,after=[],[]
  File.open("uXg.txt"){|list|
    list.readlines.each{|e|
      before << e.split("=",2)[0]
      after << e.split("=",2)[1].chomp}}
  scale =Jwc["hs"][Jwc["lg"].hex].to_f
  @jwc_temp.each do |tmp|
    case tmp
    when /hq/ ; puts "hd" #if op==1
    when /^(ch|cv|cs|cr|co|cp|ct|ck|cz|c2)/
      moji=tmp.split(" ",6)[-1].sub("\"","").sub("\n","")
      m1=moji
      for i in 0..before.size-1
        m1=m1.gsub(before[i],after[i])
      end
      moji2=m1
      tmp=tmp.split(" ",6)
      puts tmp[0..-2].join(" ")+" \""+moji2
    else
      puts tmp
    end
  end
end 
